# popt/popthelp.c File Reference

`#include "system.h"`
`#include "poptint.h"`

Go to the source code of this file.

## Functions

static void | displayArgs (poptContext con, enum poptCallbackReason foo, struct poptOption *key, const char *arg, void *data)
static const char *const | getTableTranslationDomain (const struct poptOption *table)
static const char *const | getArgDescrip (const struct poptOption *opt, const char *translation_domain)
static char * | singleOptionDefaultValue (int lineLength, const struct poptOption *opt, const char *translation_domain)
static void | singleOptionHelp (FILE *fp, int maxLeftCol, const struct poptOption *opt, const char *translation_domain)
static int | maxArgWidth (const struct poptOption *opt, const char *translation_domain)
static void | itemHelp (FILE *fp, poptItem items, int nitems, int left, const char *translation_domain)
| Display popt alias and exec help.
static void | singleTableHelp (poptContext con, FILE *fp, const struct poptOption *table, int left, const char *translation_domain)
static int | showHelpIntro (poptContext con, FILE *fp)
void | poptPrintHelp (poptContext con, FILE *fp, int flags)
| Print detailed description of options.
static int | singleOptionUsage (FILE *fp, int cursor, const struct poptOption *opt, const char *translation_domain)
static int | itemUsage (FILE *fp, int cursor, poptItem item, int nitems, const char *translation_domain)
| Display popt alias and exec usage.
static int | singleTableUsage (poptContext con, FILE *fp, int cursor, const struct poptOption *opt, const char *translation_domain)
static int | showShortOptions (const struct poptOption *opt, FILE *fp, char *str)
| Return concatenated short options for display.
void | poptPrintUsage (poptContext con, FILE *fp, int flags)
| Print terse description of options.
void | poptSetOtherOptionHelp (poptContext con, const char *text)
| Provide text to replace default "[OPTION...]" in help/usage output.

## Variables

poptOption | poptAliasOptions []
| Empty table marker to enable displaying popt alias/exec options.
poptOption | poptHelpOptions []
| Auto help table options.

## Detailed Description

Definition in file popthelp.c.

## Function Documentation

static void displayArgs | ( | poptContext | con,
|  | enum poptCallbackReason | foo,
|  | struct poptOption * | key,
|  | const char * | arg,
|  | void * | data
| ) | `[static]`

Parameters:

  | con | context
  | key | option(s)

Definition at line 19 of file popthelp.c.

References poptPrintHelp(), poptPrintUsage(), and poptOption::shortName.

static const char* const getArgDescrip | ( | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | opt | option(s)
  | translation_domain | translation domain

Definition at line 85 of file popthelp.c.

References poptOption::argDescrip, poptOption::argInfo, D_, POPT_, POPT_ARG_DOUBLE, POPT_ARG_FLOAT, POPT_ARG_INT, POPT_ARG_LONG, POPT_ARG_MASK, POPT_ARG_NONE, POPT_ARG_STRING, POPT_ARG_VAL, and poptHelpOptions.

Referenced by maxArgWidth(), singleOptionHelp(), and singleOptionUsage().

static const char* const getTableTranslationDomain | ( | const struct poptOption * | table | ) | `[static]`

Parameters:

  | table | option(s)

Definition at line 67 of file popthelp.c.

References poptOption::arg, poptOption::argInfo, poptOption::longName, POPT_ARG_INTL_DOMAIN, and poptOption::shortName.

static void itemHelp | ( | FILE * | fp,
|  | poptItem | items,
|  | int | nitems,
|  | int | left,
|  | const char * | translation_domain
| ) | `[static]`

Display popt alias and exec help.

Parameters:

  | fp | output file handle
  | items | alias/exec array
  | nitems | no. of alias/exec entries
  | translation_domain | translation domain

Definition at line 387 of file popthelp.c.

References poptItem_s::option, POPT_ARGFLAG_DOC_HIDDEN, and singleOptionHelp().

Referenced by singleTableHelp().

static int itemUsage | ( | FILE * | fp,
|  | int | cursor,
|  | poptItem | item,
|  | int | nitems,
|  | const char * | translation_domain
| ) | `[static]`

Display popt alias and exec usage.

Parameters:

  | fp | output file handle
  | item | alias/exec array
  | nitems | no. of ara/exec entries
  | translation_domain | translation domain

Definition at line 540 of file popthelp.c.

References poptOption::arg, poptItem_s::option, and POPT_ARG_INTL_DOMAIN.

Referenced by poptPrintUsage().

static int maxArgWidth | ( | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | opt | option(s)
  | translation_domain | translation domain

Definition at line 343 of file popthelp.c.

References poptOption::arg, poptOption::argInfo, getArgDescrip(), poptOption::longName, POPT_ARG_INCLUDE_TABLE, POPT_ARG_MASK, POPT_ARGFLAG_DOC_HIDDEN, POPT_ARGFLAG_ONEDASH, POPT_ARGFLAG_OPTIONAL, and poptOption::shortName.

Referenced by poptPrintHelp().

static int showHelpIntro | ( | poptContext | con,
|  | FILE * | fp
| ) | `[static]`

Parameters:

  | con | context
  | fp | output file handle

Definition at line 452 of file popthelp.c.

References optionStackEntry::argv, poptContext_s::flags, poptContext_s::optionStack, POPT_, and POPT_CONTEXT_KEEP_FIRST.

Referenced by poptPrintHelp(), and poptPrintUsage().

static int showShortOptions | ( | const struct poptOption * | opt,
|  | FILE * | fp,
|  | char * | str
| ) | `[static]`

Return concatenated short options for display.

Parameters:

  | opt | option(s)
  | fp | output file handle

Return values:

  | str | concatenation of short options

Returns:
  length of display string

Definition at line 601 of file popthelp.c.

References alloca(), poptOption::arg, poptOption::argInfo, poptOption::longName, POPT_ARG_INCLUDE_TABLE, and poptOption::shortName.

Referenced by poptPrintUsage().

static char* singleOptionDefaultValue | ( | int | lineLength,
|  | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | opt | option(s)
  | translation_domain | translation domain

Definition at line 115 of file popthelp.c.

References _free(), poptOption::arg, poptOption::argInfo, D_, POPT_ARG_DOUBLE, POPT_ARG_FLOAT, POPT_ARG_INT, POPT_ARG_LONG, POPT_ARG_MASK, POPT_ARG_NONE, POPT_ARG_STRING, and POPT_ARG_VAL.

Referenced by singleOptionHelp().

static void singleOptionHelp | ( | FILE * | fp,
|  | int | maxLeftCol,
|  | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | fp | output file handle
  | opt | option(s)
  | translation_domain | translation domain

Definition at line 182 of file popthelp.c.

References _free(), poptOption::argDescrip, poptOption::argInfo, D_, poptOption::descrip, getArgDescrip(), help, poptOption::longName, ops, POPT_ARG_DOUBLE, POPT_ARG_FLOAT, POPT_ARG_INT, POPT_ARG_LONG, POPT_ARG_MASK, POPT_ARG_NONE, POPT_ARG_STRING, POPT_ARG_VAL, POPT_ARGFLAG_AND, POPT_ARGFLAG_LOGICALOPS, POPT_ARGFLAG_NOT, POPT_ARGFLAG_ONEDASH, POPT_ARGFLAG_OPTIONAL, POPT_ARGFLAG_OR, POPT_ARGFLAG_SHOW_DEFAULT, POPT_ARGFLAG_XOR, poptOption::shortName, singleOptionDefaultValue(), and poptOption::val.

Referenced by itemHelp(), and singleTableHelp().

static int singleOptionUsage | ( | FILE * | fp,
|  | int | cursor,
|  | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | fp | output file handle
  | opt | option(s)
  | translation_domain | translation domain

Definition at line 492 of file popthelp.c.

References poptOption::argDescrip, poptOption::argInfo, getArgDescrip(), poptOption::longName, POPT_ARGFLAG_ONEDASH, and poptOption::shortName.

static void singleTableHelp | ( | poptContext | con,
|  | FILE * | fp,
|  | const struct poptOption * | table,
|  | int | left,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | fp | output file handle
  | table | option(s)
  | translation_domain | translation domain

Definition at line 411 of file popthelp.c.

References poptContext_s::aliases, poptOption::arg, poptOption::argInfo, poptContext_s::execs, itemHelp(), poptOption::longName, poptContext_s::numAliases, poptContext_s::numExecs, POPT_ARGFLAG_DOC_HIDDEN, poptAliasOptions, poptOption::shortName, and singleOptionHelp().

Referenced by poptPrintHelp().

static int singleTableUsage | ( | poptContext | con,
|  | FILE * | fp,
|  | int | cursor,
|  | const struct poptOption * | opt,
|  | const char * | translation_domain
| ) | `[static]`

Parameters:

  | fp | output file handle
  | opt | option(s)
  | translation_domain | translation domain

Definition at line 569 of file popthelp.c.

References poptOption::arg, poptOption::argInfo, poptOption::longName, POPT_ARG_INTL_DOMAIN, and poptOption::shortName.

Referenced by poptPrintUsage().

## Variable Documentation

struct poptOption poptAliasOptions[]

Initial value:

     {
        POPT_TABLEEND
    }

Empty table marker to enable displaying popt alias/exec options.

Definition at line 42 of file popthelp.c.

Referenced by singleTableHelp().

struct poptOption poptHelpOptions[]

Initial value:

     {
      { NULL, '\0', POPT_ARG_CALLBACK, (void *)&displayArgs, '\0', NULL, NULL },
      { "help", '?', 0, NULL, '?',  "Show this help message" , NULL },
      { "usage", '\0', 0, NULL, 'u',  "Display brief usage message" , NULL },

        POPT_TABLEEND
    }

Auto help table options.

Definition at line 51 of file popthelp.c.

Referenced by getArgDescrip().